#!/usr/bin/python

import pifacedigitalio as pfio
import time

# file locations
OILERFILE = "/home/pi/obd/oiler.txt" # progress towards next oil pulse
SPEEDFILE = "/home/pi/obd/speed.txt" # current vehicle speed
PERIODFILE = "/var/www/obdcontrol/oilperiod.txt" # period between oilings
ADJUSTFILE = "/var/www/obdcontrol/oiladjust.txt" # % to increase/decrease oil above 80kph
SPEEDCHKFILE = "/var/www/obdcontrol/oilspeedchk.txt" # whether to check speed before oiling

# Initial variable values
OILTIME = 6 # duration of oil solenoid pulse
OUTPUT = 1 # piface output that drives solenoid
INPUT = 0 # piface input from the manual oiler/reset button
SLEEP = 0.5 # how many second between checks of input/file
COUNTMAX = 50 # how many cycles between checks/adjustment of oilerfile
PRINT = False
PERIOD = 300.0
ADJUST = 100.0
COUNT = 1

pfio.init()

while (True):
	if pfio.digital_read(INPUT) == 1:
		pfio.digital_write(OUTPUT,1) # if button is pushed, open valve
		FILE = open(OILERFILE, 'w') # reset oiler count
		FILE.write("0.0")
		FILE.close()
	else:
		pfio.digital_write(OUTPUT,0) # close valve
		COUNT += 1
		if COUNT >= COUNTMAX:
			COUNT = 1
			
			try:
				FILE = open(SPEEDFILE,'r')
				SPEED = float(FILE.read())
				FILE.close()
			except:
				SPEED = 10.0
				if PRINT:
					print "Error opening SPEED file"	
			if PRINT:
				print "Speed:", SPEED

                  	try:
                                FILE = open(SPEEDCHKFILE,'r')
                                SPEEDCHK = FILE.read()
                                FILE.close()
                        except:
				SPEED = 10.0
                                if PRINT:
                                        print "Error opening SPEEDCHK file"

		  	if SPEEDCHK == "NO":
				SPEED = 10.0			       	

			try:
				FILE = open(OILERFILE,'r')
				OILER = float(FILE.read())
				FILE.close()
			except:
				if PRINT:
					print "Error opening OILER file"
                        if PRINT:
                                print "Oiler%:", OILER


			try:			
				FILE = open(PERIODFILE,'r')
				PERIOD = float(FILE.read())
				FILE.close()
			except:
				if PRINT:
					print "Error opening PERIOD file"
                        if PRINT:
                                print "Period:", PERIOD


			try:
				FILE = open(ADJUSTFILE,'r')
				ADJUST = float(FILE.read())
				FILE.close()
			except:
				if PRINT:
					print "Error opening ADJUST file"	
                        if PRINT:
                                print "Adjust:", ADJUST


			if SPEED < 80:
				ADJUST = 100.0 # adjustment is 100% below 80kph

			if SPEED > 5: # either increment progress or oil chain, reset  AND increment

				if OILER > 100: # 100% of dist/time has been exceeded
					pfio.digital_write(OUTPUT,1)
					time.sleep(OILTIME)
					pfio.digital_write(OUTPUT,0)
					OILER = OILER - 100
				INCREMENT = SLEEP * COUNTMAX *  ADJUST / PERIOD
				if PRINT:
					print "Increment:",INCREMENT
				try:
					FILE = open(OILERFILE, 'w')
					FILE.write(str(int(OILER + INCREMENT)))
					FILE.close()
				except:
					if PRINT:
						print "Error writing to OILER file"
				
	time.sleep(SLEEP)
